package java.lang;

import java.security.PrivilegedExceptionAction;

class SystemClassLoaderAction implements PrivilegedExceptionAction<ClassLoader>
{
    private ClassLoader parent;
    
    SystemClassLoaderAction(ClassLoader parent) {
        this.parent = parent;
    }
    
    @Override
    public ClassLoader run() throws Exception {
        String property = System.getProperty("java.system.class.loader");
        if (property == null) {
            return this.parent;
        }
        ClassLoader contextClassLoader = (ClassLoader)Class.forName(property, true, this.parent).getDeclaredConstructor(new Class[] { ClassLoader.class }).newInstance(new Object[] { this.parent });
        Thread.currentThread().setContextClassLoader(contextClassLoader);
        return contextClassLoader;
    }
}
